variables:
    IMAGE_NAME: gavinumj/cicd-pipeline
    IMAGE_TAG: python-app-1.0

stages:
  - Test
  - Build
  - Deploy

run_tests:
  stage: Test
  image: python:3.9-slim-buster
  before_script:
    - apt-get update && apt-get install make
  script:
    - make test

build_image:
  stage: Build
  image: docker:20.10.16
  services:
    -  docker:20.10.16-dind
  variables:
    DOCKER_TLS_CERTDIR: "/certs"
  before_script:
    - docker login -u $REGISTRY_USER -p $REGISTRY_PASS
  script: 
    - docker build -t $IMAGE_NAME:$IMAGE_TAG . 
    - docker push $IMAGE_NAME:$IMAGE_TAG

deploy:
  stage: Deploy
  before_script:
    - chmod 400 $SSH_KEY
  script:
    - ssh -o StrictHostKeyChecking=no -i $SSH_KEY root@146.190.165.27 "
        docker login -u $REGISTRY_USER -p $REGISTRY_PASS &&
        docker ps -aq | xargs docker stop | xargs docker rm &&
        docker run -d -p 5000:5000 $IMAGE_NAME:$IMAGE_TAG"
        
